%     VIRTUAL LAMINATE - программа для получения эффективных свойств слоистых пластин
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

clear all; %#ok<CLALL>
clc;
more off;

% #######################################################################################################
% ##                                                                                                   ##
% ##                                        НАСТРОЙКИ ПРОГРАММЫ                                        ##
% ##                                                                                                   ##
% #######################################################################################################

% Для включения возможности вывода информации на русском языке при выполнении программы в среде GNU Octave
% необходимо добавить в файл C:\Octave\Octave-4.4.0\share\octave\site\m\startup\octaverc  следующую строку:
% system("chcp 1251",1);

% ------------------------------------------ Параметры укладки ------------------------------------------

Repetition_Factor          = 1;                         % Коэффициент повторения исходной укладки (применяется первым). Если Repetition_Factor = 1, то повторения не происходит.
Symmetrization             = 'FALSE'; % TRUE | FALSE    % Симметризация укладки путем добавления ее зеркального отражения (применяется после повторения).

% ------------------------------------------- Параметры сетки -------------------------------------------

Element_Order              = 'LINEAR'; % LINEAR | QUADRATIC    % Порядок элементов
N_Elements_Ply             = 1;  % Число элементов по толщине слоя
N_Elements_Side            = 5; % Число элементов длине и ширине ячейки периодичности (также определяет габариты ячейки)
Element_Critical_Ratio     = 5;  % Максимальное соотношение сторон конечного элемента

% ----------------------------------------- Параметры расчета -------------------------------------------

Analysis_Type              = 'MECHANICAL'; % MECHANICAL | HEAT_TRANSFER | MESH_GENERATOR

                           % MECHANICAL - получение эффективных механических свойств с помощью решателя Abaqus
                           % HEAT_TRANSFER - получение эффективных свойств теплопереноса с помощью решателя Abaqus
                           % MESH_GENERATOR - только генерация сетки (без расчета)
                           
Mechanical_BC_TYPE         = 'SOFT'; % SOFT | HARD    % Тип граничных условий в механическом расчете

                           % SOFT - периодические граничные условия со свободной границей ячейки
                           % HARD - периодические граничные условия с фиксированной границей ячейки (использовать с большой осторожностью!)
                           
Constraint_Directions      = 'XYZ';    % Направления, задающие грани с фиксированной границей в случае Mechanical_BC_TYPE == HARD. Строка, состоящая из символов X, Y, Z.

Chemical_Shrinkage         = 'TRUE'; % TRUE | FALSE    % Расчет эффективных коэффициентов химической усадки помимо основных механических свойств

% ----------------------------------------- Параметры запуска -------------------------------------------

Work_Directory             = 'M:\Abaqus_Work';    % Рабочая папка для проведения расчета в Abaqus
CPU                        = 1;                   % Число используемых ядер для расчета в Abaqus

% -------------------------------------------------------------------------------------------------------

% #######################################################################################################
% ##                                                                                                   ##
% ##                                     КОНЕЦ НАСТРОЕК ПРОГРАММЫ                                      ##
% ##                                                                                                   ##
% #######################################################################################################

global ErrCode;
global Merge_Tolerance_Multiplier;
global software_version;
global software_date;
global software_year;

ErrCode = 0;
Merge_Tolerance_Multiplier = [];
software_version = [];
software_date = [];
software_year = [];

% Отсчет времени выполнения программы
tic;

% Инициализация базовых переменных
Init_Variables();

% Печать приветствия
Print_Greeting();

% Проверка параметров
if (Repetition_Factor ~= floor(Repetition_Factor))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Repetition_Factor !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (Repetition_Factor < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Repetition_Factor !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

switch Symmetrization
    case {'TRUE', 'FALSE'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Symmetrization !\n');
        fprintf (1, 'Разрешенные значения: TRUE, FALSE\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

switch Element_Order
    case {'LINEAR', 'QUADRATIC'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Element_Order !\n');
        fprintf (1, 'Разрешенные значения: LINEAR, QUADRATIC\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

if (N_Elements_Ply ~= floor(N_Elements_Ply))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра N_Elements_Ply !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (N_Elements_Ply < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра N_Elements_Ply !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (N_Elements_Side ~= floor(N_Elements_Side))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра N_Elements_Side !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (N_Elements_Side < 2)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра N_Elements_Side !\n');
    fprintf (1, 'Параметр должен быть больше или равен двум.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (Element_Critical_Ratio <= 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Element_Critical_Ratio !\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

switch Analysis_Type
    case {'MECHANICAL', 'HEAT_TRANSFER', 'MESH_GENERATOR'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Analysis_Type !\n');
        fprintf (1, 'Разрешенные значения: MECHANICAL, HEAT_TRANSFER, MESH_GENERATOR\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

switch Mechanical_BC_TYPE
    case {'SOFT', 'HARD'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Mechanical_BC_TYPE !\n');
        fprintf (1, 'Разрешенные значения: SOFT, HARD\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

if ((numel(Constraint_Directions) < 1) || (numel(Constraint_Directions) > 3))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра Constraint_Directions !\n');
    fprintf (1, 'Разрешенные значения: строка, состоящая из символов X, Y, Z.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

for i=1:numel(Constraint_Directions)
    switch Constraint_Directions(i)
        case {'X', 'Y', 'Z'}
            % Допустимые значения
        otherwise
            ErrCode = -1;
            fprintf (1, 'Недопустимое значение параметра Constraint_Directions !\n');
            fprintf (1, 'Разрешенные значения: строка, состоящая из символов X, Y, Z.\n');
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
    end
end

switch Chemical_Shrinkage
    case {'TRUE', 'FALSE'}
        % Допустимые значения
    otherwise
        ErrCode = -1;
        fprintf (1, 'Недопустимое значение параметра Chemical_Shrinkage !\n');
        fprintf (1, 'Разрешенные значения: TRUE, FALSE\n');
        fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
        toc;
        return;
end

if (CPU ~= floor(CPU))
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра CPU !\n');
    fprintf (1, 'Параметр должен быть целым числом.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

if (CPU < 1)
    ErrCode = -1;
    fprintf (1, 'Недопустимое значение параметра CPU !\n');
    fprintf (1, 'Параметр должен быть больше или равен единице.\n');
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

% Счетчики числа сообщений
N_Info = 0;
N_Warnings = 0;

% Анализ настроек программы
if (strcmp(Analysis_Type, 'MECHANICAL'))
    
    if (strcmp(Mechanical_BC_TYPE, 'HARD'))
        fprintf (1, 'ПРЕДУПРЕЖДЕНИЕ! В расчете используются периодические граничные условия с фиксированной границей\n');
        fprintf (1, '                ячейки (Mechanical_BC_TYPE = HARD). Требуется особое внимание при анализе\n');
        fprintf (1, '                полученных эффективных свойств.\n\n');
        N_Warnings = N_Warnings + 1;
    end
    
end

% Чтение материалов
switch Analysis_Type
    
    case {'MECHANICAL', 'MESH_GENERATOR'}
        
        Materials = Read_Materials_Mech();
        
         if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
        
    case 'HEAT_TRANSFER'
        
        Materials = Read_Materials_Therm();
        
        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
    
end

% Проверка свойств материалов
switch Analysis_Type
    
    case {'MECHANICAL', 'MESH_GENERATOR'}
        
        Check_Materials_Mech(Materials);
        
        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
        
    case 'HEAT_TRANSFER'
        
        Check_Materials_Therm(Materials);
        
        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
    
end

% Упорядочивание массива материалов
tmp = cell(1,1);

for i=1:size(Materials,1)
    tmp(Materials{i}.ID,1) = Materials(i);
end

Materials = tmp;

% Чтение укладки
Stacking = Read_Stacking();

 if (ErrCode < 0)
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

% Проверка укладки
Check_Stacking(Stacking, Materials);

if (ErrCode < 0)
    fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
    toc;
    return;
end

% Преобразование углов к интервалу (-90, 90]
for i=1:size(Stacking,1)
    
    if (Stacking(i,2) >= 0)
        
        Stacking(i,2) = mod(Stacking(i,2), 180);
        
        if (Stacking(i,2) > 90)
            Stacking(i,2) = Stacking(i,2) - 180;
        end
        
    else
        
        Stacking(i,2) = mod(Stacking(i,2), -180);
        
        if (Stacking(i,2) <= -90)
            Stacking(i,2) = Stacking(i,2) + 180;
        end
        
    end
    
end

% Повторение укладки
if (Repetition_Factor > 1)
    
    tmp = zeros(size(Stacking,1) * Repetition_Factor, 3);
    
    for i=1:Repetition_Factor
        
        tmp(1 + (i-1)*size(Stacking,1) : i*size(Stacking,1),:) = Stacking;
        
    end
    
    for i=1:size(tmp,1)
        tmp(i,1) = i;
    end
    
    Stacking = tmp;
    
    fprintf (1, '\nИНФОРМАЦИЯ: примено повторение укладки с коэффициентом %i.\n', Repetition_Factor);
    
    N_Info = N_Info + 1;
    
end

% Отражение укладки
if (strcmp(Symmetrization, 'TRUE'))
    
    tmp = zeros(size(Stacking,1) * 2, 3);
    
    tmp(1 : size(Stacking,1),:) = Stacking;
    
    tmp(1 + size(Stacking,1) : 2*size(Stacking,1),:) = flip(Stacking, 1);
    
    for i=1:size(tmp,1)
        tmp(i,1) = i;
    end
    
    Stacking = tmp;
    
    fprintf (1, '\nИНФОРМАЦИЯ: примено отражение укладки.\n');
    
    N_Info = N_Info + 1;
    
end

% Тест на симметрию укладки
if (size(Stacking,1) == 1)
    
    if ((Stacking(1,2) ~= 0) && (Stacking(1,2) ~= 90))
        
        fprintf (1, '\nПРЕДУПРЕЖДЕНИЕ! Укладка не является симметричной!\n');

        N_Warnings = N_Warnings + 1;
        
    end
    
else
    
    warning_flag = 0;
    
    if (mod(size(Stacking,1),2) == 1)
        
        mid_ply_index = ceil(size(Stacking,1)/2);
        
        if ((Stacking(mid_ply_index,2) ~= 0) && (Stacking(mid_ply_index,2) ~= 90))

            fprintf (1, '\nПРЕДУПРЕЖДЕНИЕ! Укладка не является симметричной!\n');

            N_Warnings = N_Warnings + 1;
            
            warning_flag = 1;

        end
        
        Array_1 = Stacking(1:floor(size(Stacking,1)/2),:);
        Array_2 = Stacking(ceil(size(Stacking,1)/2)+1:size(Stacking,1),:);
        
    else
        
        Array_1 = Stacking(1:size(Stacking,1)/2,:);
        Array_2 = Stacking(size(Stacking,1)/2+1:size(Stacking,1),:);
        
    end
    
    Array_2 = flip(Array_2,1);
    
    if (warning_flag == 0)
        
        for i=1:size(Array_1,1)
            
            if (warning_flag == 1)
                break;
            end
            
            if ((Array_1(i,2) ~= Array_2(i,2)) || (Array_1(i,3) ~= Array_2(i,3)))
                
                fprintf (1, '\nПРЕДУПРЕЖДЕНИЕ! Укладка не является симметричной!\n');

                N_Warnings = N_Warnings + 1;

                warning_flag = 1;
                
            end
            
        end
        
    end
    
end

% Тест на сбалансированность укладки
tmp = Stacking(:,2);
tmp = tmp(tmp~=0);
tmp = tmp(tmp~=90);
tmp = abs(tmp);
tmp = unique(tmp);

if (~isempty(tmp))
    
    non_balanced_flag = 0;
    
    for i=1:numel(tmp)
        
        if (non_balanced_flag == 1)
            break;
        end

        plus_theta_counter = 0;
        minus_theta_counter = 0;
        
        for j=1:size(Stacking,1)

            if ((abs(Stacking(j,2)) == tmp(i)) && (Stacking(j,2) > 0))
                plus_theta_counter = plus_theta_counter + 1;
            end
            
            if ((abs(Stacking(j,2)) == tmp(i)) && (Stacking(j,2) < 0))
                minus_theta_counter = minus_theta_counter + 1;
            end

        end
        
        if (plus_theta_counter ~= minus_theta_counter)
            
            fprintf (1, '\nПРЕДУПРЕЖДЕНИЕ! Укладка не является сбалансированной!\n');

            N_Warnings = N_Warnings + 1;

            non_balanced_flag = 1;
            
        end

    end
    
end

% Печать новой строки
if ((N_Warnings > 0) || (N_Info > 0))
    fprintf (1, '\n');
end

% Построение сетки
[NODES, ELEMENTS, RVE_Coordinates, Node_Merge_Tolerance, Ply_Elements] = Generate_Mesh(Materials, Stacking, Element_Order, N_Elements_Ply, N_Elements_Side, Element_Critical_Ratio);

% Корректировка Work_Directory
if (Work_Directory(length(Work_Directory)) == '\')
    Work_Directory = Work_Directory(1:length(Work_Directory)-1);
end

% Ветвление по типу анализа
switch Analysis_Type
    
    case 'MECHANICAL'
        
        Mechanical_Procedure(Work_Directory, CPU, NODES, ELEMENTS, RVE_Coordinates, Node_Merge_Tolerance, Chemical_Shrinkage, Mechanical_BC_TYPE, Constraint_Directions, Ply_Elements, Materials, Stacking, Element_Order);
        
        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
        
    case 'HEAT_TRANSFER'
        
        Heat_Transfer_Procedure(Work_Directory, CPU, NODES, ELEMENTS, RVE_Coordinates, Node_Merge_Tolerance, Ply_Elements, Materials, Stacking, Element_Order);
        
        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
        
    case 'MESH_GENERATOR'
        
        Write_Input_Mesh(Work_Directory, NODES, ELEMENTS, Ply_Elements, Materials, Stacking, Element_Order);

        if (ErrCode < 0)
            fprintf (1, 'Работа программы завершена с ошибкой!\n\n');
            toc;
            return;
        end
    
end

% Печать разделителя
Print_Delimiter();

% Сообщение об успешном завершении работы программы
fprintf (1, 'Работа программы завершена успешно!\n\n');

% Вывод числа предупреждений
if (N_Warnings > 0)
    fprintf (1, '\tПолучено предупреждений: %i\n', N_Warnings);
end

% Вывод числа информационных сообщений
if (N_Info > 0)
    fprintf (1, '\tПолучено информационных сообщений: %i\n', N_Info);
end

% Печать новой строки
if ((N_Warnings > 0) || (N_Info > 0))
    fprintf (1, '\n');
end

% Вывод времени выполнения программы
toc;
